import { IMagicSquare } from "./models/magic-square.interface";
import { IMagicSquareResponse } from "./models/magic-square-response.interface";
export declare class MagicSquareSolver {
    readonly ms: IMagicSquare;
    private expected;
    constructor(ms: IMagicSquare);
    /**
     * Permet de vérifier s'il s'agit bien d'un carré magique
     */
    check(): IMagicSquareResponse;
    /** Vérification de la somme des colonnes et des lignes */
    private columnAndline;
    /** Vérification de la somme de la première diagonale (de gauche à droite, du haut vers le bas) */
    private diagonaleLeftToRight;
    /** Vérification de la somme de la seconde diagonale (de droite à gauche, du haut vers le bas) */
    private diagonaleRightToLeft;
}
