"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const magic_square_solver_class_1 = require("../src/magic-square-solver.class");
describe('Magic Square Solver', function () {
    it('constructor : dimension', function () {
        var square = {
            square: [[1, 2, 3, 4], [4, 5, 6], [7, 8, 9]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('constructor : duplicate', function () {
        var square = {
            square: [[1, 2, 3], [4, 5, 6], [7, 1, 1]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('constructor : boundary', function () {
        var square = {
            square: [[1, 2, 3], [4, 5, 6], [7, 1, 10]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('constructor : boundary', function () {
        var square = {
            square: [[1, 2, 3], [4, 0, 6], [7, 1, 9]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('constructor : boundary', function () {
        var square = {
            square: [[1, 2, 3], [4, -1, 6], [7, 1, 9]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('constructor : dimension', function () {
        var square = {
            square: [[1, 3], [4, -1, 6], [7, 1, 9]],
            dimension: 3
        };
        var create = () => { new magic_square_solver_class_1.MagicSquareSolver(square); };
        chai_1.expect(create).to.throw();
    });
    it('check : diagonaleLeftToRight', function () {
        var square = {
            square: [[2, 1, 3], [4, 5, 6], [7, 8, 9]],
            dimension: 3
        };
        var mss = new magic_square_solver_class_1.MagicSquareSolver(square);
        var verify = mss.check();
        chai_1.expect(verify.status).to.be.equal(false);
        chai_1.expect(verify.message).to.be.equal("La somme de la diagonale de la gauche vers la droite n'est pas correcte");
    });
    it('check : columnAndLine', function () {
        var square = {
            square: [[1, 2, 3], [4, 5, 6], [7, 8, 9]],
            dimension: 3
        };
        var mss = new magic_square_solver_class_1.MagicSquareSolver(square);
        var verify = mss.check();
        chai_1.expect(verify.status).to.be.equal(false);
    });
    it('check : diagonaleRightToLeft', function () {
        var square = {
            square: [[1, 3, 2], [4, 5, 6], [7, 8, 9]],
            dimension: 3
        };
        var mss = new magic_square_solver_class_1.MagicSquareSolver(square);
        var verify = mss.check();
        chai_1.expect(verify.status).to.be.equal(false);
        chai_1.expect(verify.message).to.be.equal("La somme de la diagonale de la droite vers la gauche n'est pas correcte");
    });
    it('check : function', function () {
        var square = {
            square: [[2, 7, 6], [9, 5, 1], [4, 3, 8]],
            dimension: 3
        };
        var mss = new magic_square_solver_class_1.MagicSquareSolver(square);
        var verify = mss.check();
        chai_1.expect(verify.status).to.be.equal(true);
        chai_1.expect(verify.message).to.be.equal("Il s'agit bien d'un carré magique");
    });
});
